// Code generated by cdpgen. DO NOT EDIT.

// Package accessibility implements the Accessibility domain.
package accessibility

import (
	"context"

	"github.com/mafredri/cdp/protocol/internal"
	"github.com/mafredri/cdp/rpcc"
)

// domainClient is a client for the Accessibility domain.
type domainClient struct{ conn *rpcc.Conn }

// NewClient returns a client for the Accessibility domain with the connection set to conn.
func NewClient(conn *rpcc.Conn) *domainClient {
	return &domainClient{conn: conn}
}

// Disable invokes the Accessibility method. Disables the accessibility
// domain.
func (d *domainClient) Disable(ctx context.Context) (err error) {
	err = rpcc.Invoke(ctx, "Accessibility.disable", nil, nil, d.conn)
	if err != nil {
		err = &internal.OpError{Domain: "Accessibility", Op: "Disable", Err: err}
	}
	return
}

// Enable invokes the Accessibility method. Enables the accessibility domain
// which causes `AXNodeId`s to remain consistent between method calls. This
// turns on accessibility for the page, which can impact performance until
// accessibility is disabled.
func (d *domainClient) Enable(ctx context.Context) (err error) {
	err = rpcc.Invoke(ctx, "Accessibility.enable", nil, nil, d.conn)
	if err != nil {
		err = &internal.OpError{Domain: "Accessibility", Op: "Enable", Err: err}
	}
	return
}

// GetPartialAXTree invokes the Accessibility method. Fetches the
// accessibility node and partial accessibility tree for this DOM node, if it
// exists.
func (d *domainClient) GetPartialAXTree(ctx context.Context, args *GetPartialAXTreeArgs) (reply *GetPartialAXTreeReply, err error) {
	reply = new(GetPartialAXTreeReply)
	if args != nil {
		err = rpcc.Invoke(ctx, "Accessibility.getPartialAXTree", args, reply, d.conn)
	} else {
		err = rpcc.Invoke(ctx, "Accessibility.getPartialAXTree", nil, reply, d.conn)
	}
	if err != nil {
		err = &internal.OpError{Domain: "Accessibility", Op: "GetPartialAXTree", Err: err}
	}
	return
}

// GetFullAXTree invokes the Accessibility method. Fetches the entire
// accessibility tree
func (d *domainClient) GetFullAXTree(ctx context.Context) (reply *GetFullAXTreeReply, err error) {
	reply = new(GetFullAXTreeReply)
	err = rpcc.Invoke(ctx, "Accessibility.getFullAXTree", nil, reply, d.conn)
	if err != nil {
		err = &internal.OpError{Domain: "Accessibility", Op: "GetFullAXTree", Err: err}
	}
	return
}
